
struct Solution;

impl Solution {
    pub fn generate(num_rows: i32) -> Vec<Vec<i32>> {
        let mut res: Vec<Vec<i32>> = vec![];

        for i in 0..num_rows {
            let mut v = vec![];
            for j in 0..(i+1) {
                if j == 0 || j == i {
                    v.push(1);
                } else {
                    v.push(res[(i-1) as usize][(j-1) as usize] + res[(i-1) as usize][j as usize]);
                }

            }
            res.push(v);
        }

        res

    }
}


#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_generate() {
        let num_rows = 5;
        let res = Solution::generate(num_rows);
        assert_eq!(res, vec![vec![1],vec![1,1],vec![1,2,1],vec![1,3,3,1],vec![1,4,6,4,1]])
    }
}