
struct Solution;

impl Solution {
    pub fn int_to_roman(num: i32) -> String {

        let vi = vec![1,4,5,9,10,40,50,90,100,400,500,900,1000];
        let va = vec!["I", "IV", "V", "IX", "X", "XL", "L", "XC", "C", "CD", "D", "CM", "M"];

        let mut res = String::new();
        let mut num = num;
        let l = vi.len();
        let mut i = l -1;
        while num > 0 {
            while  num / vi[i] == 0  {
                i -= 1;
            }

            num -= vi[i];
            res.push_str(va[i]);
        }


        res



    }
}

#[cfg(test)]
mod tests {
    use super::*;
    #[test]
    fn test_int_to_roman() {
        assert_eq!(Solution::int_to_roman(3), "III");
        assert_eq!(Solution::int_to_roman(4), "IV");
        assert_eq!(Solution::int_to_roman(9), "IX");
        assert_eq!(Solution::int_to_roman(58), "LVIII");
        assert_eq!(Solution::int_to_roman(1994), "MCMXCIV");
    }
}