struct Solution;


impl Solution {
    pub fn is_match(s: String, p: String) -> bool {
        let mut cache = std::collections::HashMap::new();
        let  res = Solution::is_match_(0, 0, s, p, &mut cache);
        // let mut cache: std::collections::HashMap<(usize, usize), bool> = std::collections::HashMap::new();

        res

    }
    fn is_match_(i: usize, j: usize, ss: String, pp: String,  cache : &mut std::collections::HashMap<(usize, usize), bool>) -> bool {
        let len_ss = ss.len();
        let len_pp = pp.len();
        println!("len_ss: {}, len_pp: {}", len_ss, len_pp);
        println!("ss: {}, pp: {}, i: {}, j: {}", ss, pp, i, j);

         // ss 不为空, j 为空
        if i < len_ss && j == len_pp {
            return false
        }

        // ss pp 都结束 pp = 0
        if i == len_ss && j == len_pp {
            return true;
        }
        // len(pp) == 1
        if i == len_ss && j + 1 == len_pp {
            return false;
        }

        // pp 大于 2
        if i == len_ss && len_pp > 1 + j {
            if pp.chars().nth(j+1).unwrap() != '*'{

                return false;
            } else {
                let res = cache.get(&(i, j+2));
                match res {
                    Some(res) => {
                        return *res;
                    },
                    None => {
                        let res = Solution::is_match_(i, j+2, ss, pp, cache);
                        cache.insert((i, j), res);
                        return res;
                    }
                }
            }
        }




        println!("ss: {}, pp: {}, i: {}, j: {}", ss, pp, i, j);

        let res = cache.get(&(i, j));
        match res {
            Some(res) => { return *res},
            None => {
                if ss.chars().nth(i).unwrap() == pp.chars().nth(j).unwrap() || pp.chars().nth(j).unwrap() == '.'{
                    if j + 1 < len_pp && pp.chars().nth(j+1).unwrap() == '*' {
                        let res= Solution::is_match_(i+1, j, ss.clone(),  pp.clone(), cache)
                        || Solution::is_match_(i+1, j+2, ss.clone(), pp.clone(), cache)
                        || Solution::is_match_(i, j+2, ss, pp, cache);
                        cache.insert((i, j), res);
                        return res

                    } else {
                        let res = Solution::is_match_(i+1, j+1, ss,  pp, cache);
                        cache.insert((i, j),res);
                        return res
                    }
                } else {
                    // ss[i] != pp[j] && pp[j] != .
                    if j +1 < len_pp && pp.chars().nth(j+1).unwrap() == '*' {

                        let res = Solution::is_match_(i, j+2, ss, pp, cache);
                        cache.insert((i, j), res);
                        return res

                    } else {
                        cache.insert((i, j), false);
                        return false;
                    }
                }

            }
        }


    }
}


#[cfg(test)]
mod tests {
    use super::*;
    #[test]
    fn test_is_match() {

        assert_eq!(Solution::is_match("abcaaaaaaabaabcabac".to_string(), ".*ab.a.*a*a*.*b*b*".to_string()), true);
        assert_eq!(Solution::is_match("baabbbaccbccacacc".to_string(), "c*..b*a*a.*a..*c".to_string()), true);
        assert_eq!(Solution::is_match("ab".to_string(), ".*..".to_string()), true);
        assert_eq!(Solution::is_match("bbbba".to_string(), ".*a*a".to_string()), true);
        assert_eq!(Solution::is_match("aa".to_string(), "a".to_string()), false);
        assert_eq!(Solution::is_match("aa".to_string(), "a*".to_string()), true);
        assert_eq!(Solution::is_match("aaa".to_string(), "ab*a".to_string()), false);



        assert_eq!(Solution::is_match("ab".to_string(), ".*".to_string()), true);
        assert_eq!(Solution::is_match("aab".to_string(), "c*a*b".to_string()), true);
        assert_eq!(Solution::is_match("mississippi".to_string(), "mis*is*p*.".to_string()), false);
    }
}