
pub struct Solution;



impl Solution {
    pub fn two_sum(nums: Vec<i32>, target: i32) -> Vec<i32> {

        if nums.len() < 2 {
            return vec![]
        }
        let mut s: std::collections::HashMap<i32, i32> = std::collections::HashMap::new();
        for (idx, num) in nums.iter().enumerate() {
            let left = target - num;
            match s.get(num) {
                Some(v) => { return vec![*v, idx as i32]; },
                None => { s.insert(left, idx as i32); }
            }
        }

        return vec![]

    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_case_1() {
        let nums = vec![3, 2, 4];
        let target = 6;
        let res = Solution::two_sum(nums, target);
        let expect = vec![1, 2];
        assert_eq!(res, expect)
    }
}