struct Solution;

impl Solution {
    pub fn remove_duplicates(nums: &mut Vec<i32>) -> i32 {
        let mut prev = nums[0];
        const  MAX_COUNT: i32 = 2;
        let mut count = 1;
        let mut pos = 1;
        for i in 1..nums.len() {
            let n = nums[i];
            if n > prev {
                count = 1;
                nums[pos] = n;
                pos += 1;

            } else if n == prev && count < MAX_COUNT {
                count += 1;
                nums[pos] = n;
                pos += 1;
            } else {
                count += 1;
            }
            prev = n;
        }
        // println!("nums: {:?}", nums);
        pos as i32

    }
}


#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_remove_duplicates() {
        let mut nums = vec![1,1,1,2,2,3];
        let res = Solution::remove_duplicates(&mut nums);
        assert_eq!(res, 5);
        assert_eq!(nums[..res as usize], [1,1,2,2,3]);
    }

    #[test]
    fn test_remove_duplicates2() {
        let mut nums = vec![0,0,1,1,1,1,2,3,3];
        let res = Solution::remove_duplicates(&mut nums);
        assert_eq!(res, 7);
        assert_eq!(nums[..res as usize], [0,0,1,1,2,3,3]);
    }
}