struct Solution;

impl Solution {
    pub fn single_number(nums: Vec<i32>) -> i32 {
        let mut res = 0;
        for i in nums {
            res ^= i;
        }

        res

    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_single_number() {
        let nums = vec![2,2,1];
        let res = Solution::single_number(nums);
        assert_eq!(res, 1);
    }

    #[test]
    fn test_single_number2() {
        let nums = vec![4,1,2,1,2];
        let res = Solution::single_number(nums);
        assert_eq!(res, 4);
    }
}