struct Solution;

impl Solution {
    pub fn single_number(nums: Vec<i32>) -> i32 {

        let mut nums = nums;
        nums.sort();
        let mut count = 1;
        let mut prev = nums[0];

        for i in 1..nums.len() {
            if prev != nums[i] {
                if count == 1 {
                    break;
                }
                prev = nums[i];
                count = 0;
            }
            count += 1;
        }

        prev

    }
}


#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_single_number() {
        let  nums = vec![0,1,0,1,0,1,99];
        let res = Solution::single_number(nums);
        assert_eq!(res, 99);
    }
}