struct Solution;

impl Solution {
    pub fn combine(n: i32, k: i32) -> Vec<Vec<i32>> {

        let mut res = vec![];
        let mut cur = vec![];
        Solution::helper(n,k,1, &mut cur, &mut res);
        res

    }

    fn helper(n: i32, k: i32, i: i32, cur: &mut Vec<i32>, res: &mut Vec<Vec<i32>>) {
        if cur.len() == k as usize {
            let tmp = cur.clone();
            res.push(tmp);
        }

        for j in i..=n {
            cur.push(j);
            Solution::helper(n, k, j+1, cur, res);
            cur.pop();
        }
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_combine1() {
        let (n, k) = (4, 2);
        let res = Solution::combine(n, k);
        assert_eq!(res, vec![vec![1,2],vec![1,3],vec![1,4],vec![2,3],vec![2,4],vec![3,4]]);
    }

}